diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/desktop.c vnc_unixsrc/vncviewer/desktop.c
--- vnc_unixsrc.orig/vncviewer/desktop.c	2004-05-28 13:29:29.000000000 -0400
+++ vnc_unixsrc/vncviewer/desktop.c	2010-02-25 22:32:49.000000000 -0500
@@ -329,68 +2496,255 @@
  * CreateDotCursor.
  */
 
+#ifndef very_small_dot_cursor
 static Cursor
-CreateDotCursor()
+CreateDotCursor(int which)
 {
-  Cursor cursor;
-  Pixmap src, msk;
-  static char srcBits[] = { 0, 14,14,14, 0 };
-  static char mskBits[] = { 14,31,31,31,14 };
-  XColor fg, bg;
-
-  src = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), srcBits, 5, 5);
-  msk = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), mskBits, 5, 5);
-  XAllocNamedColor(dpy, DefaultColormap(dpy,DefaultScreen(dpy)), "black",
-		   &fg, &fg);
-  XAllocNamedColor(dpy, DefaultColormap(dpy,DefaultScreen(dpy)), "white",
-		   &bg, &bg);
-  cursor = XCreatePixmapCursor(dpy, src, msk, &fg, &bg, 2, 2);
-  XFreePixmap(dpy, src);
-  XFreePixmap(dpy, msk);
+	Cursor cursor;
+	Pixmap src, msk;
+	static char srcBits3[] = { 0x00, 0x02, 0x00 };
+	static char mskBits3[] = { 0x02, 0x07, 0x02 };
+	static char srcBits4[] = { 0x00, 0x06, 0x06, 0x00 };
+	static char mskBits4[] = { 0x06, 0x0f, 0x0f, 0x06 };
+	XColor fg, bg;
+
+	if (which == 3) {
+		src = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), srcBits3, 3, 3);
+		msk = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), mskBits3, 3, 3);
+	} else {
+		src = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), srcBits4, 4, 4);
+		msk = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), mskBits4, 4, 4);
+	}
+	XAllocNamedColor(dpy, DefaultColormap(dpy,DefaultScreen(dpy)), "black",
+	    &fg, &fg);
+	XAllocNamedColor(dpy, DefaultColormap(dpy,DefaultScreen(dpy)), "white",
+	    &bg, &bg);
+	cursor = XCreatePixmapCursor(dpy, src, msk, &fg, &bg, 1, 1);
+	XFreePixmap(dpy, src);
+	XFreePixmap(dpy, msk);
 
-  return cursor;
+	return cursor;
 }
+#else
+static Cursor
+CreateDotCursor()
+{
+	Cursor cursor;
+	Pixmap src, msk;
+	static char srcBits[] = { 0, 14, 0 };
+	static char mskBits[] = { 14,31,14 };
+	XColor fg, bg;
+
+	src = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), srcBits, 3, 3);
+	msk = XCreateBitmapFromData(dpy, DefaultRootWindow(dpy), mskBits, 3, 3);
+	XAllocNamedColor(dpy, DefaultColormap(dpy,DefaultScreen(dpy)), "black",
+	    &fg, &fg);
+	XAllocNamedColor(dpy, DefaultColormap(dpy,DefaultScreen(dpy)), "white",
+	    &bg, &bg);
+	cursor = XCreatePixmapCursor(dpy, src, msk, &fg, &bg, 1, 1);
+	XFreePixmap(dpy, src);
+	XFreePixmap(dpy, msk);
 
+	return cursor;
+}
+#endif
 
+int skip_maybe_sync = 0;
+void maybe_sync(int width, int height) {
+	static int singles = 0, always_skip = -1;
+	int singles_max = 64;
+
+	if (always_skip < 0) {
+		if (getenv("SSVNC_NO_MAYBE_SYNC")) {
+			always_skip = 1;
+		} else {
+			always_skip = 0;
+		}
+	}
+	if (skip_maybe_sync || always_skip) {
+		return;
+	}
+#if 0
+	if (width > 1 || height > 1) {
+		XSync(dpy, False);
+		singles = 0;
+	} else {
+		if (++singles >= singles_max) {
+			singles = 0;
+			XSync(dpy, False);
+		}
+	}
+#else
+	if (width * height >= singles_max) {
+		XSync(dpy, False);
+		singles = 0;
+	} else {
+		singles += width * height;
+		if (singles >= singles_max) {
+			XSync(dpy, False);
+			singles = 0;
+		}
+	}
+#endif
+}
 /*
- * CopyDataToScreen.
+ * FillImage.
  */
 
 void
-CopyDataToScreen(char *buf, int x, int y, int width, int height)
+FillScreen(int x, int y, int width, int height, unsigned long fill)
 {
-  if (appData.rawDelay != 0) {
-    XFillRectangle(dpy, desktopWin, gc, x, y, width, height);
+	XImage *im = image_scale ? image_scale : image;
+	int bpp = im->bits_per_pixel;
+	int Bpp = im->bits_per_pixel / 8;
+	int Bpl = im->bytes_per_line;
+	int h, widthInBytes = width * Bpp;
+	static char *buf = NULL;
+	static int buflen = 0;
+	unsigned char  *ucp;
+	unsigned short *usp;
+	unsigned int   *uip;
+	char *scr;
+	int b0, b1, b2;
 
-    XSync(dpy,False);
+#if 0
+fprintf(stderr, "FillImage bpp=%d %04dx%04d+%04d+%04d -- 0x%x\n", bpp, width, height, x, y, fill);
+#endif
+	if (appData.chatOnly) {
+		return;
+	}
 
-    usleep(appData.rawDelay * 1000);
-  }
+	if (widthInBytes > buflen || !buf)  {
+		if (buf) {
+			free(buf);
+		}
+		buflen = widthInBytes * 2;
+		buf = (char *)malloc(buflen); 
+	}
+	ucp = (unsigned char*) buf;
+	usp = (unsigned short*) buf;
+	uip = (unsigned int*) buf;
+
+	if (isLSB) {
+		b0 = 0; b1 = 1; b2 = 2;
+	} else {
+		b0 = 2; b1 = 1; b2 = 0;
+	}
 
-  if (!appData.useBGR233) {
-    int h;
-    int widthInBytes = width * myFormat.bitsPerPixel / 8;
-    int scrWidthInBytes = si.framebufferWidth * myFormat.bitsPerPixel / 8;
-
-    char *scr = (image->data + y * scrWidthInBytes
-		 + x * myFormat.bitsPerPixel / 8);
-
-    for (h = 0; h < height; h++) {
-      memcpy(scr, buf, widthInBytes);
-      buf += widthInBytes;
-      scr += scrWidthInBytes;
-    }
-  } else {
-    CopyBGR233ToScreen((CARD8 *)buf, x, y, width, height);
-  }
+	for (h = 0; h < width; h++) {
+		if (bpp == 8) {
+			*(ucp+h) = (unsigned char)  fill;
+		} else if (bpp == 16) {
+			*(usp+h) = (unsigned short) fill;
+		} else if (bpp == 24) {
+			*(ucp + 3*h + b0) = (unsigned char) ((fill & 0x0000ff) >> 0);
+			*(ucp + 3*h + b1) = (unsigned char) ((fill & 0x00ff00) >> 8);
+			*(ucp + 3*h + b2) = (unsigned char) ((fill & 0xff0000) >> 16);
+		} else if (bpp == 32) {
+			*(uip+h) = (unsigned int)   fill;
+		}
+	}
 
-#ifdef MITSHM
-  if (appData.useShm) {
-    XShmPutImage(dpy, desktopWin, gc, image, x, y, x, y, width, height, False);
-    return;
-  }
+	scr = im->data + y * Bpl + x * Bpp;
+
+	for (h = 0; h < height; h++) {
+		memcpy(scr, buf, widthInBytes);
+		scr += Bpl;
+	}
+	put_image(x, y, x, y, width, height, 1);
+	maybe_sync(width, height);
+}
+
+void copy_rect(int x, int y, int width, int height, int src_x, int src_y) {
+	char *src, *dst;
+	int i;
+	XImage *im = image_scale ? image_scale : image;
+	int Bpp = im->bits_per_pixel / 8;
+	int Bpl = im->bytes_per_line;
+	int did2 = 0;
+
+#if 0
+fprintf(stderr, "copy_rect: %04dx%04d+%04d+%04d -- %04d %04d Bpp=%d Bpl=%d\n", width, height, x, y, src_x, src_y, Bpp, Bpl);
 #endif
-  XPutImage(dpy, desktopWin, gc, image, x, y, x, y, width, height);
+	copyrect2:
+
+	if (y < src_y) {
+		src = im->data + src_y * Bpl + src_x * Bpp;
+		dst = im->data +     y * Bpl +     x * Bpp;
+		for (i = 0; i < height; i++)  {
+			memmove(dst, src, Bpp * width); 
+			src += Bpl;
+			dst += Bpl;
+		}
+	} else {
+		src = im->data + (src_y + height - 1) * Bpl + src_x * Bpp;
+		dst = im->data + (y     + height - 1) * Bpl +     x * Bpp;
+		for (i = 0; i < height; i++)  {
+			memmove(dst, src, Bpp * width); 
+			src -= Bpl;
+			dst -= Bpl;
+		}
+	}
+
+	if (image_scale && !did2) {
+		im = image;
+		Bpp = im->bits_per_pixel / 8;
+		Bpl = im->bytes_per_line;
+
+		x *= scale_factor_x;
+		y *= scale_factor_y;
+		src_x *= scale_factor_x;
+		src_y *= scale_factor_y;
+		width  = scale_round(width,  scale_factor_x);
+		height = scale_round(height, scale_factor_y);
+
+		did2 = 1;
+		goto copyrect2;
+	}
+}
+
+
+/*
+ * CopyDataToScreen.
+ */
+
+void
+CopyDataToScreen(char *buf, int x, int y, int width, int height)
+{
+	if (appData.chatOnly) {
+		return;
+	}
+	if (appData.rawDelay != 0) {
+		XFillRectangle(dpy, desktopWin, gc, x, y, width, height);
+		XSync(dpy,False);
+		usleep(appData.rawDelay * 1000);
+	}
+
+	if (appData.useBGR233) {
+		CopyBGR233ToScreen((CARD8 *)buf, x, y, width, height);
+	} else if (appData.useBGR565) {
+		CopyBGR565ToScreen((CARD16 *)buf, x, y, width, height);
+	} else {
+		int h;
+		int widthInBytes = width * myFormat.bitsPerPixel / 8;
+		int scrWidthInBytes = si.framebufferWidth * myFormat.bitsPerPixel / 8;
+		char *scr;
+		XImage *im = image_scale ? image_scale : image;
+
+		if (scrWidthInBytes != im->bytes_per_line) scrWidthInBytes = im->bytes_per_line;
+
+		scr = (im->data + y * scrWidthInBytes
+		    + x * myFormat.bitsPerPixel / 8);
+
+		for (h = 0; h < height; h++) {
+			memcpy(scr, buf, widthInBytes);
+			buf += widthInBytes;
+			scr += scrWidthInBytes;
+		}
+	}
+
+	put_image(x, y, x, y, width, height, 0);
+	maybe_sync(width, height);
 }
 
 
@@ -401,62 +2755,338 @@
 static void
 CopyBGR233ToScreen(CARD8 *buf, int x, int y, int width, int height)
 {
-  int p, q;
-  int xoff = 7 - (x & 7);
-  int xcur;
-  int fbwb = si.framebufferWidth / 8;
-  CARD8 *scr1 = ((CARD8 *)image->data) + y * fbwb + x / 8;
-  CARD8 *scrt;
-  CARD8 *scr8 = ((CARD8 *)image->data) + y * si.framebufferWidth + x;
-  CARD16 *scr16 = ((CARD16 *)image->data) + y * si.framebufferWidth + x;
-  CARD32 *scr32 = ((CARD32 *)image->data) + y * si.framebufferWidth + x;
+	XImage *im = image_scale ? image_scale : image;
+	int p, q;
+	int xoff = 7 - (x & 7);
+	int xcur;
+	int fbwb = si.framebufferWidth / 8;
+	int src_width8  = im->bytes_per_line/1;
+	int src_width16 = im->bytes_per_line/2;
+	int src_width32 = im->bytes_per_line/4;
+	CARD8 *src1 = ((CARD8 *)im->data) + y * fbwb + x / 8;
+	CARD8 *srct;
+	CARD8  *src8  = ( (CARD8 *)im->data) + y * src_width8  + x;
+	CARD16 *src16 = ((CARD16 *)im->data) + y * src_width16 + x;
+	CARD32 *src32 = ((CARD32 *)im->data) + y * src_width32 + x;
+	int b0, b1, b2;
 
-  switch (visbpp) {
+	switch (visbpp) {
 
     /* thanks to Chris Hooper for single bpp support */
 
-  case 1:
-    for (q = 0; q < height; q++) {
-      xcur = xoff;
-      scrt = scr1;
-      for (p = 0; p < width; p++) {
-	*scrt = ((*scrt & ~(1 << xcur))
-		 | (BGR233ToPixel[*(buf++)] << xcur));
-
-	if (xcur-- == 0) {
-	  xcur = 7;
-	  scrt++;
-	}
-      }
-      scr1 += fbwb;
-    }
-    break;
-
-  case 8:
-    for (q = 0; q < height; q++) {
-      for (p = 0; p < width; p++) {
-	*(scr8++) = BGR233ToPixel[*(buf++)];
-      }
-      scr8 += si.framebufferWidth - width;
-    }
-    break;
-
-  case 16:
-    for (q = 0; q < height; q++) {
-      for (p = 0; p < width; p++) {
-	*(scr16++) = BGR233ToPixel[*(buf++)];
-      }
-      scr16 += si.framebufferWidth - width;
-    }
-    break;
-
-  case 32:
-    for (q = 0; q < height; q++) {
-      for (p = 0; p < width; p++) {
-	*(scr32++) = BGR233ToPixel[*(buf++)];
-      }
-      scr32 += si.framebufferWidth - width;
-    }
-    break;
-  }
+	case 1:
+		for (q = 0; q < height; q++) {
+			xcur = xoff;
+			srct = src1;
+			for (p = 0; p < width; p++) {
+				*srct = ((*srct & ~(1 << xcur))
+					 | (BGR233ToPixel[*(buf++)] << xcur));
+
+				if (xcur-- == 0) {
+					xcur = 7;
+					srct++;
+				}
+			}
+			src1 += fbwb;
+		}
+		break;
+
+	case 8:
+		for (q = 0; q < height; q++) {
+			for (p = 0; p < width; p++) {
+				*(src8++) = BGR233ToPixel[*(buf++)];
+			}
+			src8 += src_width8 - width;
+		}
+		break;
+
+	case 16:
+		for (q = 0; q < height; q++) {
+			for (p = 0; p < width; p++) {
+				*(src16++) = BGR233ToPixel[*(buf++)];
+			}
+			src16 += src_width16 - width;
+		}
+		break;
+
+	case 24:
+		if (isLSB) {
+			b0 = 0; b1 = 1; b2 = 2;
+		} else {
+			b0 = 2; b1 = 1; b2 = 0;
+		}
+		src8  = ((CARD8 *)im->data) + (y * si.framebufferWidth + x) * 3;
+		for (q = 0; q < height; q++) {
+			for (p = 0; p < width; p++) {
+				CARD32 v = BGR233ToPixel[*(buf++)];
+				*(src8 + b0) = (unsigned char) ((v & 0x0000ff) >> 0);
+				*(src8 + b1) = (unsigned char) ((v & 0x00ff00) >> 8);
+				*(src8 + b2) = (unsigned char) ((v & 0xff0000) >> 16);
+				src8 += 3;
+			}
+			src8 += (si.framebufferWidth - width) * 3;
+		}
+		break;
+
+	case 32:
+		for (q = 0; q < height; q++) {
+			for (p = 0; p < width; p++) {
+				*(src32++) = BGR233ToPixel[*(buf++)];
+			}
+			src32 += src_width32 - width;
+		}
+		break;
+	}
+}
+
+static void
+BGR565_24bpp(CARD16 *buf, int x, int y, int width, int height)
+{
+	int p, q;
+	int b0, b1, b2;
+	XImage *im = image_scale ? image_scale : image;
+	unsigned char *src= (unsigned char *)im->data + (y * si.framebufferWidth + x) * 3;
+
+	if (isLSB) {
+		b0 = 0; b1 = 1; b2 = 2;
+	} else {
+		b0 = 2; b1 = 1; b2 = 0;
+	}
+
+	/*  case 24: */
+	for (q = 0; q < height; q++) {
+		for (p = 0; p < width; p++) {
+			CARD32 v = BGR565ToPixel[*(buf++)];
+			*(src + b0) = (unsigned char) ((v & 0x0000ff) >> 0);
+			*(src + b1) = (unsigned char) ((v & 0x00ff00) >> 8);
+			*(src + b2) = (unsigned char) ((v & 0xff0000) >> 16);
+			src += 3;
+		}
+		src += (si.framebufferWidth - width) * 3;
+	}
+}
+
+static void
+CopyBGR565ToScreen(CARD16 *buf, int x, int y, int width, int height)
+{
+	int p, q;
+	XImage *im = image_scale ? image_scale : image;
+	int src_width32 = im->bytes_per_line/4;
+	CARD32 *src32 = ((CARD32 *)im->data) + y * src_width32 + x;
+
+	if (visbpp == 24) {
+		BGR565_24bpp(buf, x, y, width, height);
+		return;
+	}
+
+	/*  case 32: */
+	for (q = 0; q < height; q++) {
+		for (p = 0; p < width; p++) {
+			*(src32++) = BGR565ToPixel[*(buf++)];
+		}
+		src32 += src_width32 - width;
+	}
+}
+
+static void reset_image(void) {
+	if (UsingShm()) {
+		ShmDetach();
+	}
+	if (image && image->data) {
+		XDestroyImage(image);
+		fprintf(stderr, "reset_image: destroyed 'image'\n");
+	}
+	image = NULL;
+	if (image_ycrop && image_ycrop->data) {
+		XDestroyImage(image_ycrop);
+		fprintf(stderr, "reset_image: destroyed 'image_ycrop'\n");
+	}
+	image_ycrop = NULL;
+	if (image_scale && image_scale->data) {
+		XDestroyImage(image_scale);
+		fprintf(stderr, "reset_image: destroyed 'image_scale'\n");
+	}
+	image_scale = NULL;
+
+	if (UsingShm()) {
+		ShmCleanup();
+	}
+	create_image();
+	XFlush(dpy);
+}
+
+void ReDoDesktop(void) {
+	int w, w0, h, h0, x, y, dw, dh;
+	int fs = 0;
+	int autoscale = 0;
+	Position x_orig, y_orig;
+	Dimension w_orig, h_orig;
+
+	if (!appData.fullScreen && appData.scale != NULL && !strcmp(appData.scale, "auto")) {
+		autoscale = 1;
+	}
+
+	fprintf(stderr, "ReDoDesktop: ycrop: %d\n", appData.yCrop);
+
+	XtVaGetValues(toplevel, XtNx, &x_orig, XtNy, &y_orig, NULL);
+	XtVaGetValues(toplevel, XtNheight, &h_orig, XtNwidth, &w_orig, NULL);
+
+	check_tall();
+
+	if (appData.yCrop) {
+		if (appData.yCrop < 0 || old_width <= 0) {
+			appData.yCrop = guessCrop();
+			fprintf(stderr, "Set -ycrop to: %d\n", appData.yCrop);
+		} else {
+			int w1 = si.framebufferWidth;
+			appData.yCrop = (w1 * appData.yCrop) / old_width;
+			if (appData.yCrop <= 100)  {
+				appData.yCrop = guessCrop();
+				fprintf(stderr, "Set small -ycrop to: %d\n", appData.yCrop);
+			}
+		}
+		fprintf(stderr, "Using -ycrop: %d\n", appData.yCrop);
+	}
+
+	old_width  = si.framebufferWidth;
+	old_height = si.framebufferHeight;
+
+	if (appData.fullScreen) {
+		if (prev_fb_width != si.framebufferWidth || prev_fb_height != si.framebufferHeight) {
+			int xmax = si.framebufferWidth;
+			int ymax = si.framebufferHeight;
+			if (appData.yCrop > 0) {
+				ymax = appData.yCrop;
+			}
+			if (scale_x > 0) {
+				xmax = scale_round(xmax, scale_factor_x);
+				ymax = scale_round(ymax, scale_factor_y);
+			}
+			if (xmax < dpyWidth || ymax < dpyHeight) {
+				FullScreenOff();
+				fs = 1;
+			}
+		}
+	}
+
+	prev_fb_width  = si.framebufferWidth;
+	prev_fb_height = si.framebufferHeight;
+
+	if (appData.fullScreen) {
+
+		int xmax = si.framebufferWidth;
+		int ymax = si.framebufferHeight;
+		if (scale_x > 0) {
+			xmax = scale_round(xmax, scale_factor_x);
+			ymax = scale_round(ymax, scale_factor_y);
+		}
+
+		if (image && image->data) {
+			int len;
+			int h = image->height;
+			int w = image->width;
+			len = image->bytes_per_line * image->height;
+			/* black out window first: */
+			memset(image->data, 0, len);
+  			XPutImage(dpy, XtWindow(desktop), gc, image, 0, 0, 0, 0, w, h);
+			XFlush(dpy);
+		}
+
+		/* XXX scaling?? */
+		XtResizeWidget(desktop, xmax, ymax, 0);
+
+		XSync(dpy, False);
+		usleep(100*1000);
+		FullScreenOn();
+		XSync(dpy, False);
+		usleep(100*1000);
+		reset_image();
+		return;
+	}
+
+	dw = appData.wmDecorationWidth;
+	dh = appData.wmDecorationHeight;
+
+	w = si.framebufferWidth;
+	h = si.framebufferHeight;
+	w0 = w;
+	h0 = h;
+	if (appData.yCrop > 0) {
+		h = appData.yCrop;
+	}
+	if (image_scale) {
+		w = scale_round(w, scale_factor_x);
+		h = scale_round(h, scale_factor_y);
+		w0 = scale_round(w0, scale_factor_x);
+		h0 = scale_round(h0, scale_factor_y);
+	}
+
+	if (w + dw >= dpyWidth) {
+		w = dpyWidth - dw;
+	}
+	if (h + dh >= dpyHeight) {
+		h = dpyHeight - dh;
+	}
+
+	if (!autoscale) {
+		XtVaSetValues(toplevel, XtNmaxWidth, w, XtNmaxHeight, h, NULL);
+	} else {
+		XtVaSetValues(toplevel, XtNmaxWidth, dpyWidth, XtNmaxHeight, dpyHeight, NULL);
+	}
+
+	XtVaSetValues(desktop, XtNwidth, w0, XtNheight, h0, NULL);
+
+	XtResizeWidget(desktop, w0, h0, 0);
+
+	if (appData.yCrop > 0) {
+		int ycrop = appData.yCrop;
+		if (image_scale) {
+			ycrop *= scale_factor_y;
+		}
+		XtVaSetValues(toplevel, XtNmaxHeight, ycrop, NULL);
+		XtVaSetValues(form,     XtNmaxHeight, ycrop, NULL);
+	}
+
+	x = (dpyWidth  - w - dw)/2;
+	y = (dpyHeight - h - dh)/2;
+
+	if (!autoscale) {
+
+		if (!getenv("VNCVIEWER_ALWAYS_RECENTER")) {
+			int x_cm_old, y_cm_old;
+			int x_cm_new, y_cm_new;
+			int x_try, y_try;
+
+			x_cm_old = (int) x_orig + ((int) w_orig)/2;
+			y_cm_old = (int) y_orig + ((int) h_orig)/2;
+
+			x_cm_new = dpyWidth/2;
+			y_cm_new = dpyHeight/2;
+
+			x_try = x + (x_cm_old - x_cm_new);
+			y_try = y + (y_cm_old - y_cm_new);
+			if (x_try < 0) {
+				x_try = 0;
+			}
+			if (y_try < 0) {
+				y_try = 0;
+			}
+			if (x_try + w + dw > dpyWidth) {
+				x_try = dpyWidth - w - dw;
+			}
+			if (y_try + h + dh > dpyHeight) {
+				y_try = dpyHeight - h - dh;
+			}
+			x = x_try;
+			y = y_try;
+		}
+
+		XtConfigureWidget(toplevel, x + dw, y + dh, w, h, 0);
+	}
+
+	reset_image();
+
+	if (fs) {
+		FullScreenOn();
+	}
 }
